{

pack functions for msg and squish
(c) 1999-2000 by raVen

!!!very slow!!!

supported compilers: borland pascal 7.x, virtual pascal 2.0b+

}
{&Use32+,LocInfo+}
{$D+,L+,I-,R-,S-,Q-}
{}
Unit rPack;
interface
Uses
 Dos, Objects, rObjects;
{}
 function    PackSquishBase(Path: String): byte;
 function    PackMsgBase(FileName: String): byte;
 function    PackJamBase(Path: String): byte;
{}
type
{( tMsgName )}
 pMsgName = ^tMsgName;
 tMsgName = Object(tObject)
  OldNum,NewNum: Longint;
  constructor Init(Num1: Longint);
 end;
{( tMsgList )}
 pMsgList = ^tMsgList;
 tMsgList = Object(trSortedCollection)
  function    Compare(Key1,Key2: Pointer): Integer; virtual;
  procedure   FillNewNumbers;
 end;
{}
implementation
Uses rAbs, rFidoMsg, rSquish, rJam, rStrings, rCommon;
{( tMsgName )}
constructor tMsgName.Init;
 begin
  OldNum:=Num1;
 end;
{( tMsgList )}
function    tMsgList.Compare;
 var
  Msg1: PMsgName absolute Key1;
  Msg2: PMsgName absolute Key2;
 begin
  if Msg1^.OldNum > Msg2^.OldNum then Compare:=1 else
   if Msg1^.OldNum < Msg2^.OldNum then Compare:=-1 else
    if Msg1^.OldNum = Msg2^.OldNum then Compare:=0
 end;
{}
procedure   tMsgList.FillNewNumbers;
 var
  x: Word;
  MsgName: PMsgName;
 begin
  if Count>0 then for x:=1 to Count do
   begin
    MsgName:=At(x-1);
    MsgName^.NewNum:=x;
   end;
 end;
{}
function    PackMsgBase(FileName: String): byte;
 procedure ReNumberMessages(MsgDir,MsgMask: String);
  const
   lr: String[8] = 'lastread';
   tmpdir: String[5] = 'temp\';
  var
   sr: SearchRec;
   MsgList: PMsgList;
   MsgName: PMsgName;
   x: Word;
   MsgExt: String;
   f: File;
   lrArr: Array[1..4] of Char;
   LastRead: LongInt absolute lrArr;
  begin
   MsgDir:=AddBackSlash(MsgDir);
   if not DExist(MsgDir) then exit;
   LastRead:=0;
   if Exist(MsgDir+lr) then
    begin
     Assign(f,MsgDir+lr); Reset(f,1);
     BlockRead(f,lrArr[3],2);
     BlockRead(f,lrArr[1],2);
     Close(f);
    end;
   MsgExt:=Point+JustExtension(MsgMask);
   New(MsgList,Init(16,16));
   FindFirst(MsgDir+MsgMask,AnyFile,sr);
   while DosError=0 do
    begin
     MsgList^.Insert(New(PMsgName,Init(CToN(ExtractWord(1,sr.Name,['.'])))));
     FindNext(sr);
    end;
   MkTree(MsgDir+TmpDir);
   MsgList^.FillNewNumbers;
   if MsgList^.Count>0 then for x:=1 to MsgList^.Count do
    begin
     MsgName:=MsgList^.At(x-1);
     if LastRead=MsgName^.OldNum then LastRead:=MsgName^.NewNum;
     CopyFile(MsgDir+NToC(MsgName^.OldNum)+MsgExt,MsgDir+TmpDir+NToC(MsgName^.NewNum)+MsgExt,False);
     KillFile(MsgDir+NToC(MsgName^.OldNum)+MsgExt);
    end;
   FindFirst(MsgDir+TmpDir+MsgMask,AnyFile,sr);
   while DosError=0 do
    begin
     MoveFile(MsgDir+TmpDir+sr.Name,MsgDir+sr.name);
     FindNext(sr);
    end;
   if Exist(MsgDir+lr) then
    begin
     Assign(f,MsgDir+lr); Rewrite(f,1);
     BlockWrite(f,lrArr[3],2);
     BlockWrite(f,lrArr[1],2);
     Close(f);
   end;
 {$IfDef VirtualPascal}
    FindClose(sr);
 {$EndIf}
   DisposeObj(MsgList);
   RmDir(RemoveBackSlash(MsgDir+TmpDir));
  end;
 begin
  RenumberMessages(JustPathName(FileName),JustFileName(FileName));
  PackMsgBase:=0;
 end;
{}
function    PackSquishBase(Path: String): byte;
 const
  tempbase: String[11] = 'kill_it';
 var
  OldBase,NewBase: pSquishBase;
  Msg: pAbsMsg;
  x: Longint;
 begin
  PackSquishBase:=1;
  if not DExist(JustPathName(Path)) then exit;
  if (not Exist(Path+SqDataExt)) or (not Exist(Path+SqIndexExt)) then exit;
  New(NewBase,Init);
  New(OldBase,Init);
  New(Msg,Init);
  if OldBase^.LoadBaseHdr(path,stDenyNone)<>0 then
   begin
    DisposeObj(Msg);
    DisposeObj(OldBase);
    DisposeObj(NewBase);
   end;
  NewBase^.SaveBaseHdr(AddBackSlash(JustPathName(Path))+tempbase,stDenyNone);
  for x:=1 to OldBase^.Count do
   begin
    if OldBase^.LoadMsg(Msg^,x)=0 then
    with NewBase^ do SaveMsg(Msg^,Count+1);
   end;
  DisposeObj(Msg);
  DisposeObj(OldBase);
  DisposeObj(NewBase);
  MoveFile(AddBackSlash(JustPathName(Path))+tempbase+SqDataExt,Path+SqDataExt);
  MoveFile(AddBackSlash(JustPathName(Path))+tempbase+SqIndexExt,Path+SqIndexExt);
  PackSquishBase:=0;
 end;
{}
function    PackJamBase(Path: String): byte;
 const
  tempbase: String[11] = 'kill_it';
 var
  OldBase,NewBase: pJamBase;
  Msg: pAbsMsg;
  x: Longint;
 begin
  PackJamBase:=1;
  if not DExist(JustPathName(Path)) then exit;
  if (not Exist(Path+JamHdrExt)) or (not Exist(Path+JamIndexExt)) or (not Exist(Path+JamTextExt)) then exit;
  New(NewBase,Init);
  New(OldBase,Init);
  New(Msg,Init);
  if OldBase^.LoadBaseHdr(path,stDenyNone)<>0 then
   begin
    DisposeObj(Msg);
    DisposeObj(OldBase);
    DisposeObj(NewBase);
   end;
  NewBase^.SaveBaseHdr(AddBackSlash(JustPathName(Path))+tempbase,stDenyNone);
  for x:=1 to OldBase^.Count do
   begin
    if OldBase^.LoadMsg(Msg^,x)=0 then
    with NewBase^ do SaveMsg(Msg^,Count+1);
   end;
  DisposeObj(Msg);
  DisposeObj(OldBase);
  DisposeObj(NewBase);
  MoveFile(AddBackSlash(JustPathName(Path))+tempbase+JamTextExt,Path+JamTextExt);
  MoveFile(AddBackSlash(JustPathName(Path))+tempbase+JamHdrExt,Path+JamHdrExt);
  MoveFile(AddBackSlash(JustPathName(Path))+tempbase+JamIndexExt,Path+JamIndexExt);
  MoveFile(AddBackSlash(JustPathName(Path))+tempbase+JamLastReadExt,Path+JamLastReadExt);
  MoveFile(AddBackSlash(JustPathName(Path))+tempbase+JamLastReadExt1,Path+JamLastReadExt1);
  PackJamBase:=0;
 end;
{}
end.
